'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactDom = require('react-dom');

var _reactDom2 = _interopRequireDefault(_reactDom);

var _hscroll = require('hscroll');

var _hscroll2 = _interopRequireDefault(_hscroll);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

// WTF react need to check children type
function getKeyByIndex(props, index) {
  var children = props.children;
  if (!children) return;
  var arr = _react.Children.toArray(children);
  var child = arr[index];
  if (!child) return;
  return child.key;
}

var Swipe = function (_Component) {
  (0, _inherits3.default)(Swipe, _Component);

  function Swipe() {
    (0, _classCallCheck3.default)(this, Swipe);
    return (0, _possibleConstructorReturn3.default)(this, (0, _getPrototypeOf2.default)(Swipe).apply(this, arguments));
  }

  (0, _createClass3.default)(Swipe, [{
    key: 'componentDidMount',
    value: function componentDidMount() {
      var el = _reactDom2.default.findDOMNode(this);
      var props = this.props;
      var n = _react.Children.count(props.children);
      this.refs.wrapper.style.width = n * el.clientWidth + 'px';
      var hscroll = this.hscroll = new _hscroll2.default(el, {
        type: 'swipe',
        threshold: props.threshold,
        fastThreshold: props.fastThreshold,
        duration: props.duration,
        autoWidth: true,
        interval: props.interval
      });
      if (props.active) hscroll.show(props.active, 0);
      this.current = props.active;
      hscroll.on('show', this.onShow.bind(this));
      if (props.play) hscroll.play();
    }
  }, {
    key: 'componentWillUnmount',
    value: function componentWillUnmount() {
      if (this.hscroll) this.hscroll.unbind();
    }
  }, {
    key: 'onShow',
    value: function onShow(n) {
      if (n === this.current) return;
      this.current = n;
      if (this.props.onShow) this.props.onShow(n);
    }
  }, {
    key: 'shouldComponentUpdate',
    value: function shouldComponentUpdate() {
      if (this.hscroll.animating) return false;
      return true;
    }
  }, {
    key: 'componentDidUpdate',
    value: function componentDidUpdate(prevProps) {
      var props = this.props;
      var hscroll = this.hscroll;
      var duration = void 0;
      if (prevProps.children && props.children) {
        // current
        var key = getKeyByIndex(prevProps, this.current);
        var nkey = getKeyByIndex(props, props.active);
        if (key === nkey) duration = 0;
      }
      hscroll.refresh();
      hscroll.show(props.active, duration);
      if (props.play) {
        hscroll.play();
      } else {
        hscroll.stop();
      }
    }
  }, {
    key: 'prev',
    value: function prev() {
      if (this.hscroll.animating) return;
      this.hscroll.stop();
      this.hscroll.prev();
    }
  }, {
    key: 'next',
    value: function next() {
      if (this.hscroll.animating) return;
      this.hscroll.stop();
      this.hscroll.next();
    }
  }, {
    key: 'render',
    value: function render() {
      var props = this.props;
      return _react2.default.createElement(
        'div',
        { style: props.style, className: props.className },
        _react2.default.createElement(
          'div',
          { ref: 'wrapper', style: { overflow: 'hidden' } },
          props.children
        )
      );
    }
  }]);
  return Swipe;
}(_react.Component);

Swipe.defaultProps = {
  //iterate items
  play: false,
  // current active item index
  active: 0,
  // maximun duration in ms for fast swipe
  threshold: 200,
  // minimum moved distance for fast swipe
  fastThreshold: 15,
  // default animation duration
  duration: 300,
  // play interval in ms
  interval: 2000
};
Swipe.propTypes = {
  active: _propTypes2.default.number,
  threshold: _propTypes2.default.number,
  fastThreshold: _propTypes2.default.number,
  duration: _propTypes2.default.number,
  onShow: _propTypes2.default.func,
  play: _propTypes2.default.bool,
  interval: _propTypes2.default.number
};
exports.default = Swipe;